#
# Pu-roxy ν񤭹ߵǽ
#
# Υ⥸塼 ASH Multimedia lab. ͤ http.pl 򻲹ͤˤƺޤ
# http://ash.jp/
#
# Copyright (c) 2003-2004 Satoshi Fukutomi <fuktommy@inter7.jp>.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: Post.pm,v 1.3 2005/04/02 02:15:21 fuktommy Exp $
#

package Pu::Post;
use Pu::Document;
use Pu::Config;
use Socket;
use FileHandle;

#----------------------------------------------------------------------#
# ºݤ˽񤭹
# : ̾, Ĥ̾, 
sub post($$$) {
	my ($host, $bbs, $message) = @_;
	my $port = 80;
	my $path = "/test/bbs.cgi";
	my $cookie = $Pu::Config::cacheDir . "/cookie.txt";
	local $_;
	my %cookie = ();
	my ($k, $v);

	# å
	open IN, $cookie;
	while (<IN>) {
		chomp;
		($k, $v) = split /=/, $_;
		$cookie{$k} = $v if ($v ne "");
	}
	close IN;
	my $str_cookie = "";
	while (($k, $v) = each %cookie) {
		$str_cookie .= " $k=$v;"
	}

	# åȤ
	my $ip = inet_aton($host);
	my $sockaddr = pack_sockaddr_in($port, $ip);
	socket(SOCKET, PF_INET, SOCK_STREAM, 0);

	# åȤ³
	connect(SOCKET, $sockaddr);
	autoflush SOCKET (1);

	# 
	print SOCKET "POST $path HTTP/1.1\n";
	print SOCKET "Host: $host\n";
	print SOCKET "User-Agent: $Pu::System::AGENT\n";
	print SOCKET "Referer: http://$host/$bbs/index2.html\n";
	print SOCKET "Cookie:$str_cookie\n";
	printf SOCKET "Content-Length:%d\n", length($message);
	print SOCKET "Connection: close\n\n";
	print SOCKET "$message\n";

	# 
	print "Content-Type: text/html;\n\n";
	my $stat = 0;
	while (<SOCKET>) {
		if (/^Set-Cookie:/ && $stat == 0) {	# å
			local @_ = split /;/, $';
			pop @_; pop @_;
			foreach (@_) {
				s/^ *//;
				($k, $v) = split /=/, $_, 2;
				$cookie{$k} = $v;
			}
			open OUT, "> $cookie";
			while (($k, $v) = each %cookie) {
				print OUT "$k=$v\n";
			}
			close OUT;
			$stat = 1;
		}
		$stat = 2 if (m|<html>|);
		s|<META.*?refresh>||;
		print if ($stat == 2);
		#print;
		$stat = 3 if (m|</html>|);
	}

	# λ
	close SOCKET;
}

#----------------------------------------------------------------------#
# 񤭹߲̤
# : URL
sub postWindow($) {
	my($url) = @_;
	$url =~ s|http://||;
	#$url =~ s|~|%7E|g;
	my $file = $Pu::Config::cacheDir . "/" .  $url;
	my %name = Pu::System::readTitle();
	my $title = $name{$url} || "";
	my $label_post = "\217\221\202\253\215\236\202\336"; # "񤭹"

	local @_ = split /\//, $url;
	my $host = $_[0];
	my $bbs  = $_[1];
	my $key  = $_[3];
	$key =~ s/\.dat$//;
	@_ = stat $file;
	my $time = $_[9];

	Pu::Document::printHeader($title);
	print "<BODY><H1>$title</H1>\n",
	      "<FORM method='post' action='$main::pu?mode=realpost&amp;url=$url'><P>",
	      "<INPUT type='submit' value='$label_post' name='submit' tabindex=1 accesskey='w'>",
	      "Name: <INPUT name='FROM' size=19 value='' tabindex=2 accesskey='n'>",
	      "E-mail: <INPUT name='mail' size=19 value='sage' tabindex=3 accesskey='m'>",
	      "<BR><TEXTAREA rows=5 cols=70 name='MESSAGE' tabindex=4 accesskey='c'></TEXTAREA>",
	      "<INPUT type='hidden' name='bbs' value='$bbs'>",
	      "<INPUT type='hidden' name='key' value='$key'>",
	      "<INPUT type='hidden' name='time' value='$time'>",
	      "</P></FORM>\n",
	      "</BODY></HTML>";
}

#----------------------------------------------------------------------#
# 񤭹ȤˡǸΥǡԤʤ
# : URL, 
sub makeDataAndPost($$) {
	my($url, $message) = @_;
	$url =~ s|http://||;
	#$url =~ s|~|%7E|g;
	local @_ = split /\//, $url;
	my $host = $_[0];
	my $bbs  = $_[1];
	post($host, $bbs, $message);
}

1;
